#!/bin/bash -e

echo "Fetching auth token and storage URL"

# fetch a new token
eval $(swift auth)

echo "Fetched auth token ${OS_AUTH_TOKEN} and storage URL ${OS_STORAGE_URL}"

# render the template with the provided values
echo "Copying and adjusting MapCache configuration file"
mkdir -p "${INSTALL_DIR}"
cd "${INSTALL_DIR}"
cat /mapcache-template.xml \
    | sed -e "s/{{OS_STORAGE_URL}}/$(echo ${OS_STORAGE_URL} | sed -e 's/[]\/$*.^[]/\\&/g')/g" \
    | sed -e "s/{{OS_AUTH_TOKEN}}/$(echo ${OS_AUTH_TOKEN} | sed -e 's/[]\/$*.^[]/\\&/g')/g" \
    | sed -e "s/{{BUCKET_NAME}}/$(echo ${BUCKET_NAME} | sed -e 's/[]\/$*.^[]/\\&/g')/g" > mapcache.xml
sed -e "s;http://localhost/ows;http://${RENDERER_HOST}/ows;" -i mapcache.xml
cd -
